entity hex27seg is
	port
	(
		hexa	: in  bit_vector(3 downto 0);
		segments : out bit_vector(6 downto 0)
	);
end hex27seg;

architecture rtl of hex27seg is

	signal b3, b2, b1, b0: bit;
	signal nb3, nb2, nb1, nb0: bit;

begin

	b3 <= hexa(3);
	b2 <= hexa(2);
	b1 <= hexa(1);
	b0 <= hexa(0);
	nb3 <= not b3;
	nb2 <= not b2;
	nb1 <= not b1;
	nb0 <= not b0;

	segments(0) <= (b3 or b2 or b1 or nb0) and (b3 or nb2 or b1 or b0) and (nb3 or nb2 or b1 or nb0) and (nb3 or b2 or nb1 or nb0); -- Escrita na forma de produto de somas
	segments(1) <= (nb3 and nb2) or (nb2 and nb0) or (nb3 and nb1 and nb0) or (nb3 and b1 and b0) or (b3 and nb1 and b0);
	segments(2) <= (b3 or b2 or nb1 or b0) and (nb3 or nb2 or b1 or b0) and (nb3 or nb2 or nb1);
	segments(3) <= (b3 or b2 or b1 or nb0) and (b3 or nb2 or b1 or b0) and (nb3 or b2 or nb1 or b0) and (nb2 or nb1 or nb0);
	segments(4) <= (nb2 and nb0) or (b3 and b2) or (b1 and nb0) or (b3 and b1);
	segments(5) <= (nb1 and nb0) or (b3 and nb2) or (b3 and b1) or (nb3 and b2 and nb1) or (nb3 and b2 and nb0);
	segments(6) <= (b3 or b2 or b1) and (nb3 or nb2 or b1 or b0) and (b3 or nb2 or nb1 or nb0);
	
end rtl;
